<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/Book/Scripts/4_world/dayzexpansion_book/classes/expansionbookcraftingcategoryrecipes.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.17</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d0/d3e/a00566_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">expansionbookcraftingcategoryrecipes.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d0/d3e/a00566.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * ExpansionBookCraftingCategoryRecipes.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License.</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="../../d4/db6/a04062.html">   13</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d4/db6/a04062.html">ExpansionBookCraftingCategoryRecipes</a> : <a class="code hl_class" href="../../d2/dc1/a03994.html">ExpansionBookCraftingCategory</a></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>{</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="../../d4/db6/a04062.html#adf7cd201911330e14e73112a0c55fcc2">   15</a></span>    ref array&lt;ref ExpansionBookCraftingRecipe&gt; <a class="code hl_variable" href="../../d4/db6/a04062.html#adf7cd201911330e14e73112a0c55fcc2">Recipes</a>;</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="../../d4/db6/a04062.html#a1bf0925d4a284bfec22203bf2500b1c9">   16</a></span>    <span class="keywordtype">bool</span> <a class="code hl_variable" href="../../d4/db6/a04062.html#a1bf0925d4a284bfec22203bf2500b1c9">m_Sorted</a>;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../d4/db6/a04062.html#a21e96dcea4fed9b897f3703b46aaffc8">   18</a></span>    <a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a> <a class="code hl_function" href="../../d4/db6/a04062.html#a21e96dcea4fed9b897f3703b46aaffc8">AddRecipe</a>(<a class="code hl_class" href="../../d4/d5e/a03542.html">RecipeBase</a> recipeBase)</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>    {</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>        <a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a> recipe = <span class="keyword">new</span> <a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a>(recipeBase);</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>        <span class="keywordflow">return</span> <a class="code hl_function" href="../../d4/db6/a04062.html#a21e96dcea4fed9b897f3703b46aaffc8">AddRecipe</a>(recipe);</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>    }</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="../../d4/db6/a04062.html#acb90d6a9225bfe59888b2935f07cd3ed">   25</a></span>    <a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a> <a class="code hl_function" href="../../d4/db6/a04062.html#acb90d6a9225bfe59888b2935f07cd3ed">AddRecipe</a>(<a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a> recipe)</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>    {<span class="comment"></span></div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="comment">        //! Discard invalid recipes</span></div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="comment"></span>        <span class="keywordflow">if</span> (!recipe.IsValid())</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>            <span class="keywordflow">return</span> NULL;</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>        <span class="keywordflow">if</span> (!<a class="code hl_variable" href="../../d4/db6/a04062.html#adf7cd201911330e14e73112a0c55fcc2">Recipes</a>)</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>            <a class="code hl_variable" href="../../d4/db6/a04062.html#adf7cd201911330e14e73112a0c55fcc2">Recipes</a> = <span class="keyword">new</span> array&lt;ref ExpansionBookCraftingRecipe&gt;;</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span><span class="comment"></span> </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span><span class="comment">        //! Check if an existing recipe produces the same result where only one ingredient is different and if so, add to it instead of adding new recipe</span></div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span><span class="comment"></span>        <span class="keywordflow">foreach</span> (<a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a> existingRecipe : <a class="code hl_variable" href="../../d4/db6/a04062.html#adf7cd201911330e14e73112a0c55fcc2">Recipes</a>)</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        {</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>            <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a>.FormatItems(recipe.Results) == existingRecipe.FormatItems(existingRecipe.Results))</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>            {</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>                <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a>.FormatItems(recipe.Ingredients[1]) == existingRecipe.FormatItems(existingRecipe.Ingredients[1]))</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>                {</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>                    CF_Log.Debug(<span class="stringliteral">&quot;Adding &quot;</span> + <a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a>.FormatItems(recipe.Ingredients[0]) + <span class="stringliteral">&quot; to &quot;</span> + <a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a>.FormatItems(existingRecipe.Ingredients[0]));</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span> </div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>                    <span class="keywordflow">foreach</span> (<a class="code hl_class" href="../../d4/d02/a04066.html">ExpansionBookCraftingItem</a> ingredient : recipe.Ingredients[0])</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>                    {</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>                        existingRecipe.Ingredients[0].Insert(ingredient);</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>                    }</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>                    <span class="keywordflow">return</span> existingRecipe;</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>                }</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>            }</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        }</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>        <a class="code hl_variable" href="../../d4/db6/a04062.html#adf7cd201911330e14e73112a0c55fcc2">Recipes</a>.Insert(recipe);</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span> </div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        recipe.CategoriesCount++;</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        <span class="keywordflow">return</span> recipe;</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>    }</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno"><a class="line" href="../../d4/db6/a04062.html#a91c84236694057ebb85e3248ed43c945">   59</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/db6/a04062.html#a91c84236694057ebb85e3248ed43c945">SortRecipes</a>(<span class="keywordtype">bool</span> splitRecipesPerResult = <span class="keyword">false</span>)</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    {</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>        <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d4/db6/a04062.html#a1bf0925d4a284bfec22203bf2500b1c9">m_Sorted</a>)</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span> </div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        <a class="code hl_variable" href="../../d4/db6/a04062.html#a1bf0925d4a284bfec22203bf2500b1c9">m_Sorted</a> = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        array&lt;ref ExpansionBookCraftingRecipe&gt; resultsRecipes;</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span> </div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>        map&lt;string, ref array&lt;ref ExpansionBookCraftingRecipe&gt;&gt; recipes = <span class="keyword">new</span> map&lt;string, ref array&lt;ref ExpansionBookCraftingRecipe&gt;&gt;;</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        <span class="keywordflow">foreach</span> (<a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a> recipe : <a class="code hl_variable" href="../../d4/db6/a04062.html#adf7cd201911330e14e73112a0c55fcc2">Recipes</a>)</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>        {</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>            recipe.SortIngredients();</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span> </div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>            <span class="keywordflow">if</span> (splitRecipesPerResult)</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>            {</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>                recipe.SortResults();</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>                <span class="keywordflow">foreach</span> (<a class="code hl_class" href="../../d4/d02/a04066.html">ExpansionBookCraftingItem</a> result : recipe.Results)</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>                {</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>                    <span class="keywordtype">string</span> format = result.<a class="code hl_function" href="../../d4/d02/a04066.html#a7fffce37b682c3a0b92cefff720a3635">Format</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>                    <a class="code hl_function" href="../../d4/db6/a04062.html#a83603719533ae4373ba840077f13c24a">AddResultsRecipe</a>(result.<a class="code hl_function" href="../../d4/d02/a04066.html#a7fffce37b682c3a0b92cefff720a3635">Format</a>(<span class="keyword">true</span>, <span class="keyword">false</span>), recipe, recipes, resultsRecipes);</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>                }</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>            }</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>            <span class="keywordflow">else</span></div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>            {</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>                <span class="keywordtype">string</span> displayName = recipe.GetDisplayName();</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>                <a class="code hl_function" href="../../d4/db6/a04062.html#a83603719533ae4373ba840077f13c24a">AddResultsRecipe</a>(displayName, recipe, recipes, resultsRecipes);</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>            }</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>        }</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        TStringArray recipeResults = recipes.GetKeyArray();</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>        recipeResults.Sort();</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span> </div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        array&lt;ref ExpansionBookCraftingRecipe&gt; sortedRecipes = <span class="keyword">new</span> array&lt;ref ExpansionBookCraftingRecipe&gt;;</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> </div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        <span class="keywordflow">foreach</span> (<span class="keywordtype">string</span> recipeResult : recipeResults)</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        {</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>            resultsRecipes = recipes.Get(recipeResult);</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>            <span class="keywordflow">foreach</span> (<a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a> resultRecipe : resultsRecipes)</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>            {</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>                sortedRecipes.Insert(resultRecipe);</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>            }</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>        }</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span> </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        <a class="code hl_variable" href="../../d4/db6/a04062.html#adf7cd201911330e14e73112a0c55fcc2">Recipes</a> = sortedRecipes;</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>    }</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno"><a class="line" href="../../d4/db6/a04062.html#a83603719533ae4373ba840077f13c24a">  106</a></span>    <span class="keyword">protected</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/db6/a04062.html#a83603719533ae4373ba840077f13c24a">AddResultsRecipe</a>(<span class="keywordtype">string</span> key, <a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a> recipe, inout map&lt;<span class="keywordtype">string</span>, ref array&lt;ref ExpansionBookCraftingRecipe&gt;&gt; recipes, inout array&lt;ref ExpansionBookCraftingRecipe&gt; resultsRecipes)</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>    {</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <span class="keywordflow">if</span> (!recipes.Find(key, resultsRecipes))</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        {</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>            resultsRecipes = <span class="keyword">new</span> array&lt;ref ExpansionBookCraftingRecipe&gt;;</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>            recipes.Insert(key, resultsRecipes);</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        }</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>        resultsRecipes.Insert(recipe);</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>    }</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>}</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span> </div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span><span class="keyword">class </span><a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a></div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>{</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#a76139736a09ccb7fd483f77fce9734d5">  119</a></span>    ref <a class="code hl_class" href="../../d4/d5e/a03542.html">RecipeBase</a> <a class="code hl_variable" href="../../d0/d3e/a00566.html#a76139736a09ccb7fd483f77fce9734d5">Recipe</a>;</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">  120</a></span>    ref array&lt;ref ExpansionBookCraftingItem&gt; <a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>;</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">  121</a></span>    ref array&lt;ref array&lt;ref ExpansionBookCraftingItem&gt;&gt; <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a>;</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#a632228d978e79fe516477b18b510288c">  122</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d0/d3e/a00566.html#a632228d978e79fe516477b18b510288c">CategoriesCount</a>;</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">  123</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">m_TempMainIndex</a>;</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span> </div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">  125</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a>(<a class="code hl_class" href="../../d4/d5e/a03542.html">RecipeBase</a> recipeBase)</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    {</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>        <a class="code hl_variable" href="../../d0/d3e/a00566.html#a76139736a09ccb7fd483f77fce9734d5">Recipe</a> = recipeBase;</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span> </div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>        <a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a> = recipeBase.<a class="code hl_function" href="../../d4/d5e/a03542.html#a8c2b9eb21d7207f1880b4b9f8e10b1d0">ExpansionGetResults</a>();</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a> = recipeBase.<a class="code hl_function" href="../../d4/d5e/a03542.html#a83472400848cd2193dc62a96249aa7bb">ExpansionGetIngredients</a>();</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span> </div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>        <span class="keywordflow">if</span> (!<a class="code hl_function" href="../../d0/d3e/a00566.html#a9dcb9b43a3d0fa9003d4c1c9d921f6b2">IsValid</a>())</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>    }</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span> </div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#a9dcb9b43a3d0fa9003d4c1c9d921f6b2">  136</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d0/d3e/a00566.html#a9dcb9b43a3d0fa9003d4c1c9d921f6b2">IsValid</a>()</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    {<span class="comment"></span></div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span><span class="comment">        //! Discard invalid recipes with no results</span></div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span><span class="comment"></span>        <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>.Count() == 0)</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span> </div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>        <span class="keywordflow">foreach</span> (array&lt;ref ExpansionBookCraftingItem&gt; items : <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a> )</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        {<span class="comment"></span></div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span><span class="comment">            //! Discard invalid recipes with no ingredients</span></div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span><span class="comment"></span>            <span class="keywordflow">if</span> (items.Count() == 0)</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>        }</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span> </div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>    }</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span> </div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#afd5acc8b635cd22eb1c5cf4e9da663c2">  152</a></span>    <span class="keywordtype">string</span> <a class="code hl_function" href="../../d0/d3e/a00566.html#afd5acc8b635cd22eb1c5cf4e9da663c2">GetDisplayName</a>()</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>    {</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>        <span class="keywordtype">string</span> recipeNameLower = <a class="code hl_variable" href="../../d0/d3e/a00566.html#a76139736a09ccb7fd483f77fce9734d5">Recipe</a>.m_Name;</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>        recipeNameLower.ToLower();</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span> </div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>        <span class="keywordtype">string</span> displayName = <a class="code hl_variable" href="../../d0/d3e/a00566.html#a76139736a09ccb7fd483f77fce9734d5">Recipe</a>.m_Name;</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span> </div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>        <span class="keywordflow">switch</span> (recipeNameLower)</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>        {</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>            <span class="keywordflow">case</span> <span class="stringliteral">&quot;#fill&quot;</span>:</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>                displayName += <span class="stringliteral">&quot; &quot;</span> + <a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>[<a class="code hl_variable" href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">m_TempMainIndex</a>].DisplayName;</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>            <span class="keywordflow">case</span> <span class="stringliteral">&quot;#str_breakdown0&quot;</span>:</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>            <span class="keywordflow">case</span> <span class="stringliteral">&quot;#str_gutandprepare0&quot;</span>:</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>            <span class="keywordflow">case</span> <span class="stringliteral">&quot;#str_prepare0&quot;</span>:</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>            <span class="keywordflow">case</span> <span class="stringliteral">&quot;#str_split0&quot;</span>:</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>            <span class="keywordflow">case</span> <span class="stringliteral">&quot;#sharpen&quot;</span>:</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>                <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>.Count() &gt; 1 &amp;&amp; GetGame().IsKindOf(<a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>[<a class="code hl_variable" href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">m_TempMainIndex</a>].ClassNames[0], <span class="stringliteral">&quot;SeedBase&quot;</span>))</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>                {</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>                    recipeNameLower = <span class="stringliteral">&quot;#str_cutoutseeds0&quot;</span>;</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>                    displayName = <span class="stringliteral">&quot;#str_cutoutseeds0&quot;</span>;</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>                }</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>                <span class="keywordflow">else</span></div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>                {</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>                    displayName += <span class="stringliteral">&quot; &quot;</span> + <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a>[0][0].DisplayName;</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>                    <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>                }</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>            <span class="keywordflow">case</span> <span class="stringliteral">&quot;#str_cutoutseeds0&quot;</span>:</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>                <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>[<a class="code hl_variable" href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">m_TempMainIndex</a>].<a class="code hl_variable" href="../../da/d8b/a01871.html#a86eee4fff35119212eb3f7309c752a34">Amount</a> &gt; 1)</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>                    displayName += <span class="stringliteral">&quot; (&quot;</span> + <a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>[<a class="code hl_variable" href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">m_TempMainIndex</a>].Amount + <span class="stringliteral">&quot;x)&quot;</span>;</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>                displayName = <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a>[0][0].DisplayName + <span class="stringliteral">&quot;: &quot;</span> + displayName;</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>            <span class="keywordflow">case</span> <span class="stringliteral">&quot;#str_craftgutsrope0&quot;</span>:</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>            <span class="keywordflow">case</span> <span class="stringliteral">&quot;#str_craftragrope0&quot;</span>:</div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>                displayName = <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a>[0][0].DisplayName + <span class="stringliteral">&quot;: &quot;</span> + displayName;</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>            <span class="keywordflow">default</span>:</div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>                <span class="keywordflow">if</span> (recipeNameLower.IndexOf(<span class="stringliteral">&quot;#str_craft&quot;</span>) == 0 || recipeNameLower.IndexOf(<span class="stringliteral">&quot;#craft&quot;</span>) == 0 || recipeNameLower == <span class="stringliteral">&quot;#str_sawwoodenlog0&quot;</span>)</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>                {<span class="comment"></span></div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span><span class="comment">                    //! TODO: Localize &quot;Craft&quot;</span></div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span><span class="comment"></span>                    displayName = <span class="stringliteral">&quot;Craft &quot;</span> + <a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>[<a class="code hl_variable" href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">m_TempMainIndex</a>].DisplayName;</div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>                    <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>[<a class="code hl_variable" href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">m_TempMainIndex</a>].<a class="code hl_variable" href="../../da/d8b/a01871.html#a86eee4fff35119212eb3f7309c752a34">Amount</a> &gt; 1)</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>                        displayName += <span class="stringliteral">&quot; (&quot;</span> + <a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>[<a class="code hl_variable" href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">m_TempMainIndex</a>].Amount + <span class="stringliteral">&quot;x)&quot;</span>;</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>                }</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>                <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>        }</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span> </div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>        <span class="keywordflow">return</span> Widget.TranslateString(displayName);</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>    }</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span> </div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#aaa8d6a3dd13512026dba89170218263f">  202</a></span>    <span class="keyword">static</span> <span class="keywordtype">string</span> <a class="code hl_function" href="../../d0/d3e/a00566.html#aaa8d6a3dd13512026dba89170218263f">FormatItems</a>(array&lt;ref ExpansionBookCraftingItem&gt; items, <span class="keywordtype">bool</span> translate = <span class="keyword">true</span>, <span class="keywordtype">bool</span> includeAmount = <span class="keyword">true</span>)</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>    {</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>        TStringArray names = <span class="keyword">new</span> TStringArray;</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span> </div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>        <span class="keywordflow">foreach</span> (<a class="code hl_class" href="../../d4/d02/a04066.html">ExpansionBookCraftingItem</a> item : items)</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>        {</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>            names.Insert(item.Format(translate, includeAmount));</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>        }</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span> </div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>        <span class="keywordflow">return</span> <a class="code hl_class" href="../../da/dee/a04366.html">ExpansionString</a>.<a class="code hl_function" href="../../da/dee/a04366.html#a27b7f32ee011adde9187079efee8cf0d">JoinStrings</a>(names);</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>    }</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span> </div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#a4ad2d2ee60cefdb119fb956d5589e3b0">  214</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d1/d44/a00098.html#abd30a4e7e2c525ef0849dbb932b4eb6e">CanDo</a>(<a class="code hl_class" href="../../df/de5/a03966.html">PlayerBase</a> player, array&lt;EntityAI&gt; items)</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>    {</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>        <span class="keywordflow">foreach</span> (array&lt;ref ExpansionBookCraftingItem&gt; ingredients : <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a>)</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>        {</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>            <span class="keywordflow">foreach</span> (<a class="code hl_class" href="../../d4/d02/a04066.html">ExpansionBookCraftingItem</a> ingredient : ingredients)</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>            {</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>                <span class="keywordflow">if</span> (!ingredient.CanUseInRecipe(player, items, <span class="keyword">this</span>))</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>                    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>            }</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>        }</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span> </div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>    }</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span> </div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#a2bc18d19ae0d9fdfcbcaefe352da9200">  228</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d3e/a00566.html#a2bc18d19ae0d9fdfcbcaefe352da9200">SortResults</a>()</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>    {</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>        map&lt;string, ref ExpansionBookCraftingItem&gt; results = <span class="keyword">new</span> map&lt;string, ref ExpansionBookCraftingItem&gt;;</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span> </div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>        <span class="keywordflow">foreach</span> (<a class="code hl_class" href="../../d4/d02/a04066.html">ExpansionBookCraftingItem</a> result : <a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a>)</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>        {</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>            <span class="keywordtype">string</span> format = result.Format(<span class="keyword">true</span>, <span class="keyword">false</span>);</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>            results.Insert(format, result);</div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span>        }</div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span> </div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>        TStringArray resultsKeys = results.GetKeyArray();</div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>        resultsKeys.Sort();</div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span> </div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>        array&lt;ref ExpansionBookCraftingItem&gt; sortedResults = <span class="keyword">new</span> array&lt;ref ExpansionBookCraftingItem&gt;;</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span> </div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>        <span class="keywordflow">foreach</span> (<span class="keywordtype">string</span> resultKey : resultsKeys)</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>        {</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>            sortedResults.Insert(results.Get(resultKey));</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        }</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span> </div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>        <a class="code hl_variable" href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a> = sortedResults;</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>    }</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span> </div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno"><a class="line" href="../../d0/d3e/a00566.html#a9894dd9702beef57da2e96be2f19ccd7">  251</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d0/d3e/a00566.html#a9894dd9702beef57da2e96be2f19ccd7">SortIngredients</a>()</div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>    {</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a>.Count(); i++)</div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>        {</div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>            map&lt;string, ref ExpansionBookCraftingItem&gt; ingredients = <span class="keyword">new</span> map&lt;string, ref ExpansionBookCraftingItem&gt;;</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span> </div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>            <span class="keywordflow">foreach</span> (<a class="code hl_class" href="../../d4/d02/a04066.html">ExpansionBookCraftingItem</a> ingredient : <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a>[i])</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>            {</div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>                <span class="keywordtype">string</span> format = ingredient.Format(<span class="keyword">true</span>, <span class="keyword">false</span>);</div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>                ingredients.Insert(format, ingredient);</div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>            }</div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span> </div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>            TStringArray ingredientsKeys = ingredients.GetKeyArray();</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>            ingredientsKeys.Sort();</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span> </div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>            array&lt;ref ExpansionBookCraftingItem&gt; sortedIngredients = <span class="keyword">new</span> array&lt;ref ExpansionBookCraftingItem&gt;;</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span> </div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span>            <span class="keywordflow">foreach</span> (<span class="keywordtype">string</span> ingredientsKey : ingredientsKeys)</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>            {</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>                sortedIngredients.Insert(ingredients.Get(ingredientsKey));</div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>            }</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span> </div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>            <a class="code hl_variable" href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a>[i] = sortedIngredients;</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>        }</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>    }</div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>}</div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span> </div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html">  278</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d4/d02/a04066.html">ExpansionBookCraftingItem</a></div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span>{</div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html#a95a3c4b08cad6ab38e4e6b0472b07a27">  280</a></span>    <span class="keywordtype">string</span> <a class="code hl_variable" href="../../d4/d02/a04066.html#a95a3c4b08cad6ab38e4e6b0472b07a27">DisplayName</a>;</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html#a49d2f2548f5949de27af139d4860fc05">  281</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d4/d02/a04066.html#a49d2f2548f5949de27af139d4860fc05">Amount</a>;</div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html#ac13cf4ea0ed9041d9736b3834120e570">  282</a></span>    autoptr TStringArray <a class="code hl_variable" href="../../d4/d02/a04066.html#ac13cf4ea0ed9041d9736b3834120e570">ClassNames</a> = <span class="keyword">new</span> TStringArray;</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span> </div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html#a955f06b13f486b908356b7399ea43937">  284</a></span>    <span class="keywordtype">bool</span> <a class="code hl_variable" href="../../d4/d02/a04066.html#a955f06b13f486b908356b7399ea43937">m_CanUseInRecipe</a>;</div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html#a7612985a7aae106e650ecfecf25e2b78">  285</a></span>    <a class="code hl_class" href="../../d7/d82/a03774.html">ItemBase</a> <a class="code hl_variable" href="../../d4/d02/a04066.html#a7612985a7aae106e650ecfecf25e2b78">m_PlayerItem</a>;</div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span> </div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html#a36bf61939725c7e02b9fa38073e2d9c9">  287</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d02/a04066.html#a36bf61939725c7e02b9fa38073e2d9c9">ExpansionBookCraftingItem</a>(<span class="keywordtype">string</span> displayName, <span class="keywordtype">int</span> amount, TStringArray classNames = NULL)</div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span>    {</div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span>        <a class="code hl_variable" href="../../d4/d02/a04066.html#a95a3c4b08cad6ab38e4e6b0472b07a27">DisplayName</a> = displayName;</div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>        <a class="code hl_variable" href="../../d4/d02/a04066.html#a49d2f2548f5949de27af139d4860fc05">Amount</a> = amount;</div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span>        <span class="keywordflow">if</span> (classNames)</div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span>            <a class="code hl_variable" href="../../d4/d02/a04066.html#ac13cf4ea0ed9041d9736b3834120e570">ClassNames</a> = classNames;</div>
<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span>    }</div>
<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span> </div>
<div class="line"><a id="l00295" name="l00295"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html#a7fffce37b682c3a0b92cefff720a3635">  295</a></span>    <span class="keywordtype">string</span> <a class="code hl_function" href="../../d4/d02/a04066.html#a7fffce37b682c3a0b92cefff720a3635">Format</a>(<span class="keywordtype">bool</span> translate = <span class="keyword">true</span>, <span class="keywordtype">bool</span> includeAmount = <span class="keyword">true</span>)</div>
<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span>    {</div>
<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span>        <span class="keywordflow">if</span> (translate)</div>
<div class="line"><a id="l00298" name="l00298"></a><span class="lineno">  298</span>        {</div>
<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span>            <span class="keywordflow">if</span> (includeAmount &amp;&amp; <a class="code hl_variable" href="../../d4/d02/a04066.html#a49d2f2548f5949de27af139d4860fc05">Amount</a> &gt; 1)</div>
<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>                <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d4/d02/a04066.html#a49d2f2548f5949de27af139d4860fc05">Amount</a>.ToString() + <span class="stringliteral">&quot;x &quot;</span> + <a class="code hl_variable" href="../../d4/d02/a04066.html#a95a3c4b08cad6ab38e4e6b0472b07a27">DisplayName</a>;</div>
<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span>            <span class="keywordflow">else</span></div>
<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span>                <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d4/d02/a04066.html#a95a3c4b08cad6ab38e4e6b0472b07a27">DisplayName</a>;</div>
<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span>        }</div>
<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span>        {</div>
<div class="line"><a id="l00306" name="l00306"></a><span class="lineno">  306</span>            <span class="keywordflow">return</span> <a class="code hl_class" href="../../da/dee/a04366.html">ExpansionString</a>.<a class="code hl_function" href="../../da/dee/a04366.html#a27b7f32ee011adde9187079efee8cf0d">JoinStrings</a>(<a class="code hl_variable" href="../../d4/d02/a04066.html#ac13cf4ea0ed9041d9736b3834120e570">ClassNames</a>);</div>
<div class="line"><a id="l00307" name="l00307"></a><span class="lineno">  307</span>        }</div>
<div class="line"><a id="l00308" name="l00308"></a><span class="lineno">  308</span>    }</div>
<div class="line"><a id="l00309" name="l00309"></a><span class="lineno">  309</span> </div>
<div class="line"><a id="l00310" name="l00310"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html#aba56c3c8086a619229892bc59e3a0ded">  310</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d4/d02/a04066.html#aba56c3c8086a619229892bc59e3a0ded">CanUseInRecipe</a>()</div>
<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span>    {</div>
<div class="line"><a id="l00312" name="l00312"></a><span class="lineno">  312</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d4/d02/a04066.html#a955f06b13f486b908356b7399ea43937">m_CanUseInRecipe</a>;</div>
<div class="line"><a id="l00313" name="l00313"></a><span class="lineno">  313</span>    }</div>
<div class="line"><a id="l00314" name="l00314"></a><span class="lineno">  314</span><span class="comment"></span> </div>
<div class="line"><a id="l00315" name="l00315"></a><span class="lineno">  315</span><span class="comment">    //! Check whether this item is present in items and can be used in recipe</span></div>
<div class="line"><a id="l00316" name="l00316"></a><span class="lineno"><a class="line" href="../../d4/d02/a04066.html#a50c0ad89bcea51f1bcadcd5cebc806d3">  316</a></span><span class="comment"></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d4/d02/a04066.html#a50c0ad89bcea51f1bcadcd5cebc806d3">CanUseInRecipe</a>(<a class="code hl_class" href="../../df/de5/a03966.html">PlayerBase</a> player, array&lt;EntityAI&gt; items, <a class="code hl_function" href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a> recipe)</div>
<div class="line"><a id="l00317" name="l00317"></a><span class="lineno">  317</span>    {</div>
<div class="line"><a id="l00318" name="l00318"></a><span class="lineno">  318</span>        <a class="code hl_variable" href="../../d4/d02/a04066.html#a7612985a7aae106e650ecfecf25e2b78">m_PlayerItem</a> = NULL;</div>
<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span>        <a class="code hl_variable" href="../../d4/d02/a04066.html#a955f06b13f486b908356b7399ea43937">m_CanUseInRecipe</a> = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00320" name="l00320"></a><span class="lineno">  320</span> </div>
<div class="line"><a id="l00321" name="l00321"></a><span class="lineno">  321</span>        <span class="keywordflow">foreach</span> (EntityAI item : items)</div>
<div class="line"><a id="l00322" name="l00322"></a><span class="lineno">  322</span>        {</div>
<div class="line"><a id="l00323" name="l00323"></a><span class="lineno">  323</span>            <span class="keywordflow">foreach</span> (<span class="keywordtype">string</span> className : <a class="code hl_variable" href="../../d4/d02/a04066.html#ac13cf4ea0ed9041d9736b3834120e570">ClassNames</a>)</div>
<div class="line"><a id="l00324" name="l00324"></a><span class="lineno">  324</span>            {</div>
<div class="line"><a id="l00325" name="l00325"></a><span class="lineno">  325</span>                <span class="keywordflow">if</span> (className != item.GetType() &amp;&amp; !GetGame().IsKindOf(item.GetType(), className))</div>
<div class="line"><a id="l00326" name="l00326"></a><span class="lineno">  326</span>                    <span class="keywordflow">continue</span>;</div>
<div class="line"><a id="l00327" name="l00327"></a><span class="lineno">  327</span> </div>
<div class="line"><a id="l00328" name="l00328"></a><span class="lineno">  328</span>                <a class="code hl_class" href="../../d7/d82/a03774.html">ItemBase</a> itemBase = <a class="code hl_class" href="../../d7/d82/a03774.html">ItemBase</a>.Cast(item);</div>
<div class="line"><a id="l00329" name="l00329"></a><span class="lineno">  329</span><span class="comment"></span> </div>
<div class="line"><a id="l00330" name="l00330"></a><span class="lineno">  330</span><span class="comment">                //! As CanDo and CheckConditions expect an array of two ingredients, but we are only interested in whether</span></div>
<div class="line"><a id="l00331" name="l00331"></a><span class="lineno">  331</span><span class="comment">                //! the current item could be used in this recipe, we insert it twice</span></div>
<div class="line"><a id="l00332" name="l00332"></a><span class="lineno">  332</span><span class="comment"></span>                recipe.Recipe.m_IngredientsSorted[0] = itemBase;</div>
<div class="line"><a id="l00333" name="l00333"></a><span class="lineno">  333</span>                recipe.Recipe.m_IngredientsSorted[1] = itemBase;</div>
<div class="line"><a id="l00334" name="l00334"></a><span class="lineno">  334</span> </div>
<div class="line"><a id="l00335" name="l00335"></a><span class="lineno">  335</span>                <span class="keywordflow">if</span> (recipe.Recipe.CanDo(recipe.Recipe.m_IngredientsSorted, player) &amp;&amp; recipe.Recipe.CheckConditions(recipe.Recipe.m_IngredientsSorted))</div>
<div class="line"><a id="l00336" name="l00336"></a><span class="lineno">  336</span>                {</div>
<div class="line"><a id="l00337" name="l00337"></a><span class="lineno">  337</span>                    <a class="code hl_variable" href="../../d4/d02/a04066.html#a7612985a7aae106e650ecfecf25e2b78">m_PlayerItem</a> = itemBase;</div>
<div class="line"><a id="l00338" name="l00338"></a><span class="lineno">  338</span>                    <a class="code hl_variable" href="../../d4/d02/a04066.html#a955f06b13f486b908356b7399ea43937">m_CanUseInRecipe</a> = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00339" name="l00339"></a><span class="lineno">  339</span>                    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00340" name="l00340"></a><span class="lineno">  340</span>                }</div>
<div class="line"><a id="l00341" name="l00341"></a><span class="lineno">  341</span>            }</div>
<div class="line"><a id="l00342" name="l00342"></a><span class="lineno">  342</span>        }</div>
<div class="line"><a id="l00343" name="l00343"></a><span class="lineno">  343</span> </div>
<div class="line"><a id="l00344" name="l00344"></a><span class="lineno">  344</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00345" name="l00345"></a><span class="lineno">  345</span>    }</div>
<div class="line"><a id="l00346" name="l00346"></a><span class="lineno">  346</span>}</div>
<div class="ttc" id="aa00098_html_abd30a4e7e2c525ef0849dbb932b4eb6e"><div class="ttname"><a href="../../d1/d44/a00098.html#abd30a4e7e2c525ef0849dbb932b4eb6e">CanDo</a></div><div class="ttdeci">override bool CanDo(ItemBase ingredients[], PlayerBase player)</div><div class="ttdef"><b>Definition:</b> <a href="../../d1/d44/a00098_source.html#l00155">expansioncraftfloorkit.c:155</a></div></div>
<div class="ttc" id="aa00566_html_a21ece2d7b7bd97208169448ba1467a1b"><div class="ttname"><a href="../../d0/d3e/a00566.html#a21ece2d7b7bd97208169448ba1467a1b">m_TempMainIndex</a></div><div class="ttdeci">int m_TempMainIndex</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00123">expansionbookcraftingcategoryrecipes.c:123</a></div></div>
<div class="ttc" id="aa00566_html_a2b07d6fec14e8aeaec704ef01f260b0c"><div class="ttname"><a href="../../d0/d3e/a00566.html#a2b07d6fec14e8aeaec704ef01f260b0c">Ingredients</a></div><div class="ttdeci">ref array&lt; ref array&lt; ref ExpansionBookCraftingItem &gt; &gt; Ingredients</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00121">expansionbookcraftingcategoryrecipes.c:121</a></div></div>
<div class="ttc" id="aa00566_html_a2bc18d19ae0d9fdfcbcaefe352da9200"><div class="ttname"><a href="../../d0/d3e/a00566.html#a2bc18d19ae0d9fdfcbcaefe352da9200">SortResults</a></div><div class="ttdeci">void SortResults()</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00228">expansionbookcraftingcategoryrecipes.c:228</a></div></div>
<div class="ttc" id="aa00566_html_a3b78e4290131780c6bc45fe41dde3335"><div class="ttname"><a href="../../d0/d3e/a00566.html#a3b78e4290131780c6bc45fe41dde3335">ExpansionBookCraftingRecipe</a></div><div class="ttdeci">void ExpansionBookCraftingRecipe(RecipeBase recipeBase)</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00125">expansionbookcraftingcategoryrecipes.c:125</a></div></div>
<div class="ttc" id="aa00566_html_a632228d978e79fe516477b18b510288c"><div class="ttname"><a href="../../d0/d3e/a00566.html#a632228d978e79fe516477b18b510288c">CategoriesCount</a></div><div class="ttdeci">int CategoriesCount</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00122">expansionbookcraftingcategoryrecipes.c:122</a></div></div>
<div class="ttc" id="aa00566_html_a76139736a09ccb7fd483f77fce9734d5"><div class="ttname"><a href="../../d0/d3e/a00566.html#a76139736a09ccb7fd483f77fce9734d5">Recipe</a></div><div class="ttdeci">ExpansionBookCraftingCategoryRecipes Recipe</div></div>
<div class="ttc" id="aa00566_html_a9894dd9702beef57da2e96be2f19ccd7"><div class="ttname"><a href="../../d0/d3e/a00566.html#a9894dd9702beef57da2e96be2f19ccd7">SortIngredients</a></div><div class="ttdeci">void SortIngredients()</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00251">expansionbookcraftingcategoryrecipes.c:251</a></div></div>
<div class="ttc" id="aa00566_html_a9dcb9b43a3d0fa9003d4c1c9d921f6b2"><div class="ttname"><a href="../../d0/d3e/a00566.html#a9dcb9b43a3d0fa9003d4c1c9d921f6b2">IsValid</a></div><div class="ttdeci">bool IsValid()</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00136">expansionbookcraftingcategoryrecipes.c:136</a></div></div>
<div class="ttc" id="aa00566_html_aaa8d6a3dd13512026dba89170218263f"><div class="ttname"><a href="../../d0/d3e/a00566.html#aaa8d6a3dd13512026dba89170218263f">FormatItems</a></div><div class="ttdeci">static string FormatItems(array&lt; ref ExpansionBookCraftingItem &gt; items, bool translate=true, bool includeAmount=true)</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00202">expansionbookcraftingcategoryrecipes.c:202</a></div></div>
<div class="ttc" id="aa00566_html_aaebc84863693b67f3ed22b5c7c991a3e"><div class="ttname"><a href="../../d0/d3e/a00566.html#aaebc84863693b67f3ed22b5c7c991a3e">Results</a></div><div class="ttdeci">ref array&lt; ref ExpansionBookCraftingItem &gt; Results</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00120">expansionbookcraftingcategoryrecipes.c:120</a></div></div>
<div class="ttc" id="aa00566_html_afd5acc8b635cd22eb1c5cf4e9da663c2"><div class="ttname"><a href="../../d0/d3e/a00566.html#afd5acc8b635cd22eb1c5cf4e9da663c2">GetDisplayName</a></div><div class="ttdeci">string GetDisplayName()</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00152">expansionbookcraftingcategoryrecipes.c:152</a></div></div>
<div class="ttc" id="aa01871_html_a86eee4fff35119212eb3f7309c752a34"><div class="ttname"><a href="../../da/d8b/a01871.html#a86eee4fff35119212eb3f7309c752a34">Amount</a></div><div class="ttdeci">int Amount</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d8b/a01871_source.html#l00086">expansionmarketreserveitem.c:86</a></div></div>
<div class="ttc" id="aa03542_html"><div class="ttname"><a href="../../d4/d5e/a03542.html">RecipeBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../da/dec/a00080_source.html#l00013">craftterritoryflagkit.c:14</a></div></div>
<div class="ttc" id="aa03542_html_a83472400848cd2193dc62a96249aa7bb"><div class="ttname"><a href="../../d4/d5e/a03542.html#a83472400848cd2193dc62a96249aa7bb">RecipeBase::ExpansionGetIngredients</a></div><div class="ttdeci">array&lt; ref array&lt; ref ExpansionBookCraftingItem &gt; &gt; ExpansionGetIngredients()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/dc8/a09091_source.html#l00017">recipebase.c:17</a></div></div>
<div class="ttc" id="aa03542_html_a8c2b9eb21d7207f1880b4b9f8e10b1d0"><div class="ttname"><a href="../../d4/d5e/a03542.html#a8c2b9eb21d7207f1880b4b9f8e10b1d0">RecipeBase::ExpansionGetResults</a></div><div class="ttdeci">array&lt; ref ExpansionBookCraftingItem &gt; ExpansionGetResults()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/dc8/a09091_source.html#l00114">recipebase.c:114</a></div></div>
<div class="ttc" id="aa03774_html"><div class="ttname"><a href="../../d7/d82/a03774.html">ItemBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d7f/a00287_source.html#l00001">expansionbaselights.c:2</a></div></div>
<div class="ttc" id="aa03966_html"><div class="ttname"><a href="../../df/de5/a03966.html">PlayerBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d29/a08947_source.html#l00013">playerbase.c:14</a></div></div>
<div class="ttc" id="aa03994_html"><div class="ttname"><a href="../../d2/dc1/a03994.html">ExpansionBookCraftingCategory</a></div><div class="ttdef"><b>Definition:</b> <a href="../../dd/de6/a00548_source.html#l00013">expansionbookcraftingcategory.c:14</a></div></div>
<div class="ttc" id="aa04062_html"><div class="ttname"><a href="../../d4/db6/a04062.html">ExpansionBookCraftingCategoryRecipes</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00013">expansionbookcraftingcategoryrecipes.c:14</a></div></div>
<div class="ttc" id="aa04062_html_a1bf0925d4a284bfec22203bf2500b1c9"><div class="ttname"><a href="../../d4/db6/a04062.html#a1bf0925d4a284bfec22203bf2500b1c9">ExpansionBookCraftingCategoryRecipes::m_Sorted</a></div><div class="ttdeci">bool m_Sorted</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00016">expansionbookcraftingcategoryrecipes.c:16</a></div></div>
<div class="ttc" id="aa04062_html_a21e96dcea4fed9b897f3703b46aaffc8"><div class="ttname"><a href="../../d4/db6/a04062.html#a21e96dcea4fed9b897f3703b46aaffc8">ExpansionBookCraftingCategoryRecipes::AddRecipe</a></div><div class="ttdeci">ExpansionBookCraftingRecipe AddRecipe(RecipeBase recipeBase)</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00018">expansionbookcraftingcategoryrecipes.c:18</a></div></div>
<div class="ttc" id="aa04062_html_a83603719533ae4373ba840077f13c24a"><div class="ttname"><a href="../../d4/db6/a04062.html#a83603719533ae4373ba840077f13c24a">ExpansionBookCraftingCategoryRecipes::AddResultsRecipe</a></div><div class="ttdeci">protected void AddResultsRecipe(string key, ExpansionBookCraftingRecipe recipe, inout map&lt; string, ref array&lt; ref ExpansionBookCraftingRecipe &gt; &gt; recipes, inout array&lt; ref ExpansionBookCraftingRecipe &gt; resultsRecipes)</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00106">expansionbookcraftingcategoryrecipes.c:106</a></div></div>
<div class="ttc" id="aa04062_html_a91c84236694057ebb85e3248ed43c945"><div class="ttname"><a href="../../d4/db6/a04062.html#a91c84236694057ebb85e3248ed43c945">ExpansionBookCraftingCategoryRecipes::SortRecipes</a></div><div class="ttdeci">void SortRecipes(bool splitRecipesPerResult=false)</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00059">expansionbookcraftingcategoryrecipes.c:59</a></div></div>
<div class="ttc" id="aa04062_html_acb90d6a9225bfe59888b2935f07cd3ed"><div class="ttname"><a href="../../d4/db6/a04062.html#acb90d6a9225bfe59888b2935f07cd3ed">ExpansionBookCraftingCategoryRecipes::AddRecipe</a></div><div class="ttdeci">ExpansionBookCraftingRecipe AddRecipe(ExpansionBookCraftingRecipe recipe)</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00025">expansionbookcraftingcategoryrecipes.c:25</a></div></div>
<div class="ttc" id="aa04062_html_adf7cd201911330e14e73112a0c55fcc2"><div class="ttname"><a href="../../d4/db6/a04062.html#adf7cd201911330e14e73112a0c55fcc2">ExpansionBookCraftingCategoryRecipes::Recipes</a></div><div class="ttdeci">ref array&lt; ref ExpansionBookCraftingRecipe &gt; Recipes</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00015">expansionbookcraftingcategoryrecipes.c:15</a></div></div>
<div class="ttc" id="aa04066_html"><div class="ttname"><a href="../../d4/d02/a04066.html">ExpansionBookCraftingItem</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00278">expansionbookcraftingcategoryrecipes.c:279</a></div></div>
<div class="ttc" id="aa04066_html_a36bf61939725c7e02b9fa38073e2d9c9"><div class="ttname"><a href="../../d4/d02/a04066.html#a36bf61939725c7e02b9fa38073e2d9c9">ExpansionBookCraftingItem::ExpansionBookCraftingItem</a></div><div class="ttdeci">void ExpansionBookCraftingItem(string displayName, int amount, TStringArray classNames=NULL)</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00287">expansionbookcraftingcategoryrecipes.c:287</a></div></div>
<div class="ttc" id="aa04066_html_a49d2f2548f5949de27af139d4860fc05"><div class="ttname"><a href="../../d4/d02/a04066.html#a49d2f2548f5949de27af139d4860fc05">ExpansionBookCraftingItem::Amount</a></div><div class="ttdeci">int Amount</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00281">expansionbookcraftingcategoryrecipes.c:281</a></div></div>
<div class="ttc" id="aa04066_html_a50c0ad89bcea51f1bcadcd5cebc806d3"><div class="ttname"><a href="../../d4/d02/a04066.html#a50c0ad89bcea51f1bcadcd5cebc806d3">ExpansionBookCraftingItem::CanUseInRecipe</a></div><div class="ttdeci">bool CanUseInRecipe(PlayerBase player, array&lt; EntityAI &gt; items, ExpansionBookCraftingRecipe recipe)</div><div class="ttdoc">Check whether this item is present in items and can be used in recipe.</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00316">expansionbookcraftingcategoryrecipes.c:316</a></div></div>
<div class="ttc" id="aa04066_html_a7612985a7aae106e650ecfecf25e2b78"><div class="ttname"><a href="../../d4/d02/a04066.html#a7612985a7aae106e650ecfecf25e2b78">ExpansionBookCraftingItem::m_PlayerItem</a></div><div class="ttdeci">ItemBase m_PlayerItem</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00285">expansionbookcraftingcategoryrecipes.c:285</a></div></div>
<div class="ttc" id="aa04066_html_a7fffce37b682c3a0b92cefff720a3635"><div class="ttname"><a href="../../d4/d02/a04066.html#a7fffce37b682c3a0b92cefff720a3635">ExpansionBookCraftingItem::Format</a></div><div class="ttdeci">string Format(bool translate=true, bool includeAmount=true)</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00295">expansionbookcraftingcategoryrecipes.c:295</a></div></div>
<div class="ttc" id="aa04066_html_a955f06b13f486b908356b7399ea43937"><div class="ttname"><a href="../../d4/d02/a04066.html#a955f06b13f486b908356b7399ea43937">ExpansionBookCraftingItem::m_CanUseInRecipe</a></div><div class="ttdeci">bool m_CanUseInRecipe</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00284">expansionbookcraftingcategoryrecipes.c:284</a></div></div>
<div class="ttc" id="aa04066_html_a95a3c4b08cad6ab38e4e6b0472b07a27"><div class="ttname"><a href="../../d4/d02/a04066.html#a95a3c4b08cad6ab38e4e6b0472b07a27">ExpansionBookCraftingItem::DisplayName</a></div><div class="ttdeci">string DisplayName</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00280">expansionbookcraftingcategoryrecipes.c:280</a></div></div>
<div class="ttc" id="aa04066_html_aba56c3c8086a619229892bc59e3a0ded"><div class="ttname"><a href="../../d4/d02/a04066.html#aba56c3c8086a619229892bc59e3a0ded">ExpansionBookCraftingItem::CanUseInRecipe</a></div><div class="ttdeci">bool CanUseInRecipe()</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00310">expansionbookcraftingcategoryrecipes.c:310</a></div></div>
<div class="ttc" id="aa04066_html_ac13cf4ea0ed9041d9736b3834120e570"><div class="ttname"><a href="../../d4/d02/a04066.html#ac13cf4ea0ed9041d9736b3834120e570">ExpansionBookCraftingItem::ClassNames</a></div><div class="ttdeci">autoptr TStringArray ClassNames</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3e/a00566_source.html#l00282">expansionbookcraftingcategoryrecipes.c:282</a></div></div>
<div class="ttc" id="aa04366_html"><div class="ttname"><a href="../../da/dee/a04366.html">ExpansionString</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d8b/a00821_source.html#l00013">expansionstring.c:14</a></div></div>
<div class="ttc" id="aa04366_html_a27b7f32ee011adde9187079efee8cf0d"><div class="ttname"><a href="../../da/dee/a04366.html#a27b7f32ee011adde9187079efee8cf0d">ExpansionString::JoinStrings</a></div><div class="ttdeci">static string JoinStrings(TStringArray strings, string glue=&quot;, &quot;)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d8b/a00821_source.html#l00119">expansionstring.c:119</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_962bfa1893272c9ca8d900ccfa6a09f5.html">Book</a></li><li class="navelem"><a class="el" href="../../dir_5f6b997996f72d4bae47b189b5fbd491.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_7bf89cc13cab6aae2e93239962874a6d.html">4_world</a></li><li class="navelem"><a class="el" href="../../dir_fa5e500ddafd5d7c04b93352737ee725.html">dayzexpansion_book</a></li><li class="navelem"><a class="el" href="../../dir_9db33dfb44715fe21a4a4bee27ac0054.html">classes</a></li><li class="navelem"><a class="el" href="../../d0/d3e/a00566.html">expansionbookcraftingcategoryrecipes.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
